/* header file for dealing with the cookie jar */

#ifndef _COOKIE_H
#define _COOKIE_H

union clong {
	char	aschar[4];
	long	aslong;
};

struct cookie {
	union clong tag;
	long value;
};

typedef struct cookie COOKIE;

#define CJAR	((COOKIE **) 0x5a0L)

#endif /* _COOKIE_H */

typedef struct
{
    unsigned long   b_free;
    unsigned long   b_total;
    unsigned long   b_secsiz;
    unsigned long   b_clsiz;
} DISKINFO;

#define diskinfo DISKINFO

typedef struct BASEPAGE
{
   long            p_lowtpa;
   long            p_hitpa ;
   long            p_tbase ;
   long            p_tlen  ;
   long            p_dbase ;
   long            p_dlen  ;
   long            p_bbase ;
   long            p_blen  ;
   long            p_dta   ;
   long            p_parent;
   int                 p_env[3];
   int                 fill[105];
}basepage;


typedef   struct F78
            {
             char 	*PFAD;
             int  	ATTR;
             DTA	*dta;
             } f78;
typedef  struct F75
            {
              char  *expfad;
              basepage *bpage;
            }f75;

typedef    struct F86
            {
             char  *pf1;
             char  *pf2;
            }f86;
typedef struct F54
           {
             diskinfo *info;
             int  drv;
           }f54;

typedef  struct F71
           {
           char       *buf;
           int  drive;
           }f71;
typedef struct F63
           {
            int		handle;
            long	count;
            char	*buffer;
           }f63;
typedef struct F66
           {
            long offs;
            int   hndl;
            int   skmod;
           }f66;

typedef struct F67
           {
            int  fattr;
            int   wflag;
            char    *fnm;
           }f67;

typedef struct F87
           {
            int  wf;
            int   handl;
            long *dostme;
           }f87;

typedef struct PARA
{
  long	retcode;
  int	fktn;
   union
      {
         int	zeichen;
         f78	fu78;
         char	*dspfad;
         f75	fu75;
         f86	fu86;
         f54	fu54;
         f71	fu71;
         int	LEER;
         DTA	*dta;
         f63	fu63;
         f66	fu66;
         f67	fu67;
         f87	fu87;
      } mix;
}para;

typedef struct MSG_TYP
{
  int		what;
  int		size;
  char		*ptr;
  char		*name;
  int		an;
  int		fill;
}msg_typ;

typedef struct cinfo {
		para	*params;
struct	kerinfo *kernel;
		int		LW;
long	(*mygemdos)(msg_typ *pars);
}CINFO;
